# coding: utf-8

"""
Licensed to Cloudera, Inc. under one
or more contributor license agreements.  See the NOTICE file
distributed with this work for additional information
regarding copyright ownership.  Cloudera, Inc. licenses this file
to you under the Apache License, Version 2.0 (the
"License"); you may not use this file except in compliance
with the License.  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
"""


import pprint
import re  # noqa: F401

import six


class MigratingGroup(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'virtual_instance_group_name': 'str',
        'virtual_instance_ids': 'list[str]'
    }

    attribute_map = {
        'virtual_instance_group_name': 'virtualInstanceGroupName',
        'virtual_instance_ids': 'virtualInstanceIds'
    }

    def __init__(self, virtual_instance_group_name=None, virtual_instance_ids=None):  # noqa: E501
        """MigratingGroup - a model defined in Swagger"""  # noqa: E501

        self._virtual_instance_group_name = None
        self._virtual_instance_ids = None
        self.discriminator = None

        self.virtual_instance_group_name = virtual_instance_group_name
        if virtual_instance_ids is not None:
            self.virtual_instance_ids = virtual_instance_ids

    @property
    def virtual_instance_group_name(self):
        """Gets the virtual_instance_group_name of this MigratingGroup.  # noqa: E501

        Name of virtual instance group to which these virtual instances belong  # noqa: E501

        :return: The virtual_instance_group_name of this MigratingGroup.  # noqa: E501
        :rtype: str
        """
        return self._virtual_instance_group_name

    @virtual_instance_group_name.setter
    def virtual_instance_group_name(self, virtual_instance_group_name):
        """Sets the virtual_instance_group_name of this MigratingGroup.

        Name of virtual instance group to which these virtual instances belong  # noqa: E501

        :param virtual_instance_group_name: The virtual_instance_group_name of this MigratingGroup.  # noqa: E501
        :type: str
        """
        if virtual_instance_group_name is None:
            raise ValueError("Invalid value for `virtual_instance_group_name`, must not be `None`")  # noqa: E501

        self._virtual_instance_group_name = virtual_instance_group_name

    @property
    def virtual_instance_ids(self):
        """Gets the virtual_instance_ids of this MigratingGroup.  # noqa: E501

        Virtual instance ids in this group  # noqa: E501

        :return: The virtual_instance_ids of this MigratingGroup.  # noqa: E501
        :rtype: list[str]
        """
        return self._virtual_instance_ids

    @virtual_instance_ids.setter
    def virtual_instance_ids(self, virtual_instance_ids):
        """Sets the virtual_instance_ids of this MigratingGroup.

        Virtual instance ids in this group  # noqa: E501

        :param virtual_instance_ids: The virtual_instance_ids of this MigratingGroup.  # noqa: E501
        :type: list[str]
        """

        self._virtual_instance_ids = virtual_instance_ids

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MigratingGroup):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
