# coding: utf-8

"""
Licensed to Cloudera, Inc. under one
or more contributor license agreements.  See the NOTICE file
distributed with this work for additional information
regarding copyright ownership.  Cloudera, Inc. licenses this file
to you under the Apache License, Version 2.0 (the
"License"); you may not use this file except in compliance
with the License.  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
"""


import pprint
import re  # noqa: F401

import six


class ExternalDatabaseServerUsage(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'deployments': 'list[str]',
        'clusters': 'dict(str, list[str])'
    }

    attribute_map = {
        'deployments': 'deployments',
        'clusters': 'clusters'
    }

    def __init__(self, deployments=None, clusters=None):  # noqa: E501
        """ExternalDatabaseServerUsage - a model defined in Swagger"""  # noqa: E501

        self._deployments = None
        self._clusters = None
        self.discriminator = None

        if deployments is not None:
            self.deployments = deployments
        if clusters is not None:
            self.clusters = clusters

    @property
    def deployments(self):
        """Gets the deployments of this ExternalDatabaseServerUsage.  # noqa: E501

        Deployments that use the specified database server  # noqa: E501

        :return: The deployments of this ExternalDatabaseServerUsage.  # noqa: E501
        :rtype: list[str]
        """
        return self._deployments

    @deployments.setter
    def deployments(self, deployments):
        """Sets the deployments of this ExternalDatabaseServerUsage.

        Deployments that use the specified database server  # noqa: E501

        :param deployments: The deployments of this ExternalDatabaseServerUsage.  # noqa: E501
        :type: list[str]
        """

        self._deployments = deployments

    @property
    def clusters(self):
        """Gets the clusters of this ExternalDatabaseServerUsage.  # noqa: E501

        Clusters that use the specified database server, by deployment  # noqa: E501

        :return: The clusters of this ExternalDatabaseServerUsage.  # noqa: E501
        :rtype: dict(str, list[str])
        """
        return self._clusters

    @clusters.setter
    def clusters(self, clusters):
        """Sets the clusters of this ExternalDatabaseServerUsage.

        Clusters that use the specified database server, by deployment  # noqa: E501

        :param clusters: The clusters of this ExternalDatabaseServerUsage.  # noqa: E501
        :type: dict(str, list[str])
        """

        self._clusters = clusters

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ExternalDatabaseServerUsage):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
